-----------------------------------------
-- Selecting Data from Multiple Tables --
-----------------------------------------

-- Simple SELECT Statement using multiple tables

SELECT Sales.SalesOrderDetail.SalesOrderId,
       Sales.SalesOrderDetail.SalesOrderDetailId,
       Production.Product.ProductId,
       Production.Product.Name,
       Sales.SalesOrderDetail.UnitPrice,
       Sales.SalesOrderDetail.UnitPriceDiscount,
       Sales.SalesOrderDetail.LineTotal
FROM   Sales.SalesOrderDetail, 
       Production.Product
WHERE  Sales.SalesOrderDetail.ProductID=Production.Product.ProductId
  AND  Sales.SalesOrderDetail.SalesOrderId=43659


-- Using Aliases

SELECT SAL_SOD.SalesOrderId, 
       SAL_SOD.SalesOrderDetailId, 
       PRO_P.ProductId,
       PRO_P.Name, 
       SAL_SOD.UnitPrice,
       SAL_SOD.UnitPriceDiscount,
       SAL_SOD.LineTotal
FROM   Sales.SalesOrderDetail SAL_SOD, 
       Production.Product PRO_P
WHERE  SAL_SOD.ProductID=PRO_P.ProductId
  AND  SAL_SOD.SalesOrderId=43659


-- Using the INNER JOIN Syntax

SELECT SAL_SOD.SalesOrderId,  
       SAL_SOD.SalesOrderDetailId, 
       PRO_P.ProductId,
       PRO_P.name, 
       SAL_SOD.UnitPrice,
       SAL_SOD.UnitPriceDiscount,
       SAL_SOD.LineTotal
FROM   Sales.SalesOrderDetail SAL_SOD
       INNER JOIN Production.Product PRO_P
       ON SAL_SOD.ProductID=PRO_P.ProductId
WHERE  SAL_SOD.SalesOrderId=43659

SELECT PR_P.ProductID,PR_P.Name,PR_PPP.[Primary],PR_PPP.ModifiedDate
FROM Production.Product PR_P 
     INNER JOIN Production.ProductProductPhoto PR_PPP
     ON PR_P.ProductID=PR_PPP.ProductId and PR_PPP.[Primary]=1
WHERE PR_P.ProductID<100


-- Using More than Two Tables

SELECT PR_Product.ProductID, PR_Product.Name, PR_ProductPhoto.[Primary], PR_ProductPhoto.ModifiedDate,
       PR_Photo.LargePhotoFileName
FROM   Production.Product PR_Product 
       INNER JOIN Production.ProductProductPhoto PR_ProductPhoto
          INNER JOIN Production.ProductPhoto PR_Photo
          ON PR_ProductPhoto.ProductPhotoID=PR_Photo.ProductPhotoID
       ON PR_Product.ProductID=PR_ProductPhoto.ProductId 
WHERE  PR_ProductPhoto.ModifiedDate<='20000101'



-- Using LEFT JOIN

SELECT V.VendorID,V.AccountNumber,V.[Name],
       P.ProductID,P.[Name] 
FROM   Purchasing.Vendor V
       LEFT JOIN Purchasing.ProductVendor PV
          INNER JOIN Production.Product P
          ON PV.ProductID=P.ProductID
       ON V.VendorID=PV.VendorID

SELECT V.VendorID,V.AccountNumber,V.[Name],
       P.ProductID,P.[Name] 
FROM   Purchasing.Vendor V
       LEFT JOIN Purchasing.ProductVendor PV
          INNER JOIN Production.Product P
          ON PV.ProductID=P.ProductID
       ON V.VendorID=PV.VendorID
WHERE  P.ProductID IS NULL


-- Using RIGHT JOIN

SELECT P.ProductID,P.[Name],PV.VendorID
FROM Purchasing.ProductVendor PV
     INNER JOIN Production.Product P ------------ uses INNER JOIN
     ON PV.ProductID=P.ProductID

SELECT P.ProductID,P.[Name] ,PV.VendorID
FROM Purchasing.ProductVendor PV
     RIGHT JOIN Production.Product P
     ON PV.ProductID=P.ProductID


-- Using FULL JOIN

SELECT V.VendorID,V.AccountNumber,V.[Name],
       P.ProductID,P.[Name] 
FROM   Purchasing.Vendor V
       FULL JOIN Purchasing.ProductVendor PV
           FULL JOIN Production.Product P
           ON PV.ProductID=P.ProductID
       ON V.VendorID=PV.VendorID








