---------------------------------------------------------------------
-- Designing and Using Stored Procedures to Retrieve Scalar Values --
---------------------------------------------------------------------

-- Using OUTPUT Parameters

CREATE PROC ReturnAVowel (@WhatVowel tinyint,@Vowel char(1) output)
AS
BEGIN
  SELECT @Vowel= CASE @WhatVowel WHEN 1 THEN 'A'
                                 WHEN 2 THEN 'E'
                                 WHEN 3 THEN 'I'
                                 WHEN 4 THEN 'O'
                                 WHEN 5 THEN 'U'
                                 ELSE NULL
                 END
END

DECLARE @Vowel char(1)
EXEC ReturnAVowel 1,@Vowel ------------ does not use OUTPUT keyword
SELECT 'Vowel'=@Vowel

DECLARE @Vowel char(1)
EXEC ReturnAVowel 1,@Vowel OUT
SELECT 'Vowel'=@Vowel


CREATE PROC ReturnAVowelAndItsAsciiCode 
    (@WhatVowel tinyint,@Vowel char(1) OUTPUT,@Asciicode tinyint OUTPUT)
AS
BEGIN
  SELECT @Vowel= CASE @WhatVowel  WHEN 1 THEN 'A'
                                  WHEN 2 THEN 'E'
                                  WHEN 3 THEN 'I'
                                  WHEN 4 THEN 'O'
                                  WHEN 5 THEN 'U'
                              ELSE NULL
                 END
  SET @AsciiCode=ASCII(@Vowel)
END

DECLARE @Vowel char(1),
         @AsciiCode tinyint
EXEC ReturnAVowelAndItsAsciiCode 1,@Vowel OUTPUT,@AsciiCode OUTPUT
SELECT 'Vowel'=@Vowel,'Ascii code '=@AsciiCode
