CREATE FUNCTION dbo.GetInterest( @NumPeriods int, @PercentInterest money  )
RETURNS @InterestTable TABLE
   (
      Num int,
      I money
   )
AS
BEGIN
   DECLARE @N int
   SET @N = 0
   DECLARE @ITot money
   SET @ITot = 1
   WHILE @N < @NumPeriods
   BEGIN
      SET @N = @N + 1
      SET @ITot = @ITot * (1 + (@PercentInterest / 100))
      INSERT INTO @InterestTable VALUES(@N, @ITot)
   END
   RETURN
END


SELECT * FROM GetInterest(10, 6)


SELECT * FROM dbo.GetSales(200000)


SELECT GetSales.SalesOrderID, GetInterest.Num as Year, 
    GetSales.TotalDue * GetInterest.I AS FutureValue
FROM dbo.GetSales(200000) AS GetSales CROSS JOIN
dbo.GetInterest(3, 8) AS GetInterest
ORDER BY GetSales.SalesOrderID
