Public Class Form1
    Dim WithEvents myConnection As SqlClient.SqlConnection
    Dim bPause As Boolean = False
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        myConnection = New SqlClient.SqlConnection(My.Settings.AdventureWorksConnectionString)

    End Sub

    Private Sub myConnection_StateChange(ByVal sender As Object, ByVal e As System.Data.StateChangeEventArgs) Handles myConnection.StateChange
        Select Case e.CurrentState
            Case ConnectionState.Connecting
                tssMessages.Text = "Connecting"
            Case ConnectionState.Open
                tssMessages.Text = "Connection Open"
            Case ConnectionState.Closed
                tssMessages.Text = "Connection Closed"
            Case ConnectionState.Executing
                tssMessages.Text = "Executing..."
            Case Else
                tssMessages.Text = ""
        End Select
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click
        Dim myCommand As New SqlClient.SqlCommand()
        ShowSteps("Dim myCommand As New SqlClient.SqlCommand()")
        With myCommand
            ShowSteps("With myCommand")
            If rbTSQL.Checked Then
                .CommandText = txtTSQL.Text
                ShowSteps(".CommandText = txtTSQL.Text")
                .CommandType = CommandType.Text
                ShowSteps(".CommandType = CommandType.Text")
                .Connection = myConnection
                ShowSteps(".Connection = myConnection")
            End If
            If rbSP.Checked Then
                .CommandText = "TestTable_Insert"
                ShowSteps(".CommandText = ""TestTable_Insert""")
                .CommandType = CommandType.StoredProcedure
                ShowSteps(".CommandType = CommandType.StoredProcedure")
                .Connection = myConnection
                ShowSteps(".Connection = myConnection")
                .Parameters.Add("@Name", SqlDbType.NVarChar)
                ShowSteps(".Parameters.Add(""@Name"", SqlDbType.NVarChar)")
                .Parameters.Add("@Description", SqlDbType.NVarChar)
                ShowSteps(".Parameters.Add(""@Description"", SqlDbType.NVarChar)")
                .Parameters("@Name").Value = txtName.Text
                ShowSteps(".Parameters(""@Name"").Value = txtName.Text")
                .Parameters("@Description").Value = txtDescription.Text
                ShowSteps(".Parameters(""@Description"").Value = txtDescription.Text")
            End If
            Try
                myConnection.Open()
                ShowSteps("myConnection.Open()")
                .ExecuteNonQuery()
                ShowSteps(".ExecuteNonQuery()")
                myConnection.Close()
                ShowSteps("myConnection.Close()")
            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End With
        ShowSteps("End With")
    End Sub
    Private Sub ShowSteps(ByVal text As String)
        If cbSteps.Checked Then
            bPause = True
            With lbSteps
                .Items.Add(text)
                .SelectedIndex = .Items.Count - 1
            End With
            While bPause
                System.Windows.Forms.Application.DoEvents()
            End While
        End If
    End Sub
    
    Private Sub btnNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNext.Click
        bPause = False
    End Sub

    Private Sub cbSteps_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbSteps.CheckedChanged
        btnNext.Enabled = cbSteps.Checked
    End Sub
End Class
