USE [AdventureWorks]
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
SET ANSI_PADDING ON
GO
-- Create the new table
CREATE TABLE [Person].[ChrismasMails](
	[EMailID] [int],
	[FirstName] [dbo].[Name] NOT NULL,
	[LastName] [dbo].[Name] NOT NULL,
	[EmailAddress] [nvarchar](50)  NULL,
	[EmailSender] [nvarchar](50)  NULL
)
GO
-- Recursive Common table expression to get all the information about employees
WITH MailDestinations(EmployeeID,FirstName, LastName, EmailAddress,EMailSender)
AS
(
	SELECT	HumanResources.Employee.EmployeeID,
			Person.Contact.FirstName, 
			Person.Contact.LastName, 
			Person.Contact.EmailAddress,
			CONVERT(nvarchar(50),'') as EMailSender
		FROM HumanResources.Employee 
			INNER JOIN Person.Contact 
				ON HumanResources.Employee.ContactID = Person.Contact.ContactID
		WHERE     (HumanResources.Employee.ManagerID IS NULL)
	UNION ALL
	SELECT	e.EmployeeID, 
			Person.Contact.FirstName, 
			Person.Contact.LastName, 
			Person.Contact.EmailAddress,
			d.EmailAddress as EmailSender
		FROM HumanResources.Employee as e 
			INNER JOIN Person.Contact 
				ON e.ContactID = Person.Contact.ContactID 
			JOIN MailDestinations AS d 
				ON e.ManagerID = d.EmployeeID
)
-- Insert all the information into the new table
Insert into [Person].[ChrismasMails]
	select * from MailDestinations
