CREATE TRIGGER Production.Product_DeleteTrigger 
   ON  Production.Product 
   AFTER DELETE
AS 
BEGIN
   SET NOCOUNT ON;
    INSERT INTO [AdventureWorks].[Production].[ProductHistory]
           ([ProductID],[Name],[ProductNumber],[MakeFlag]
           ,[FinishedGoodsFlag],[Color],[SafetyStockLevel]
           ,[ReorderPoint],[StandardCost],[ListPrice]
           ,[Size],[SizeUnitMeasureCode],[WeightUnitMeasureCode]
           ,[Weight],[DaysToManufacture],[ProductLine]
           ,[Class],[Style],[ProductSubcategoryID]
           ,[ProductModelID],[SellStartDate],[SellEndDate]
           ,[DiscontinuedDate],[rowguid],[ModifiedDate]
           ,[Action],[UserName])
      SELECT [ProductID],[Name],[ProductNumber],[MakeFlag]
           ,[FinishedGoodsFlag],[Color],[SafetyStockLevel]
           ,[ReorderPoint],[StandardCost],[ListPrice]
           ,[Size],[SizeUnitMeasureCode],[WeightUnitMeasureCode]
           ,[Weight],[DaysToManufacture],[ProductLine]
           ,[Class],[Style],[ProductSubcategoryID]
           ,[ProductModelID],[SellStartDate],[SellEndDate]
           ,[DiscontinuedDate],[rowguid],GetDate(),'D',USER_NAME()
         FROM deleted
END
 