
Public Class Form1
    Friend WithEvents App As New Application
    Private Sub ConnectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectToolStripMenuItem.Click
        Try
            App.Connect()
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub App_ChangeComnnectionStatus(ByVal connected As Boolean) Handles App.ChangeComnnectionStatus
        ConnectToolStripMenuItem.Visible = Not connected
        DisconnectToolStripMenuItem.Visible = connected
        tssConnected.Visible = connected
        tssDisconnected.Visible = Not connected
        TestTableActionsToolStripMenuItem.Enabled = connected
        SalesReasonActionsToolStripMenuItem.Enabled = True
    End Sub
    Private Sub ChnageConnectionStringToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChangeConnectionToolStripMenuItem.Click
        Dim servername As String = ""

        servername = InputBox("Enter your server name", "Change connection", "(local)")
        App.ConnectionString = String.Format("Data Source={0};Initial Catalog=AdventureWorks;Integrated Security=True", servername)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub GetRowsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetRowsToolStripMenuItem.Click
        LoadData()
    End Sub
    Private Sub LoadData()
        Dim T As New AdventureWorksDataSet.TestTableDataTable
        Dim TA As New AdventureWorksDataSetTableAdapters.TestTableTableAdapter
        TA.Fill(T)
        DataGridView1.DataSource = T
    End Sub

    Private Sub TSQLToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TSQLToolStripMenuItem.Click
        Const SQLSentence As String = "DELETE FROM [AdventureWorks].[dbo].[TestTable] WHERE id={0}"
        Dim Count As Integer = 0
        For Each r As DataGridViewRow In DataGridView1.SelectedRows
            Dim com As New SqlClient.SqlCommand(String.Format(SQLSentence, r.Cells(0).Value))
            With com
                .Connection = App.Connection
                Count += .ExecuteNonQuery
            End With
        Next
        MsgBox(String.Format("{0} rows deleted", Count))
        LoadData()
    End Sub

    
    Private Sub StoredProcedureToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StoredProcedureToolStripMenuItem.Click
        Dim Com As New SqlClient.SqlCommand("TestTable_Delete")
        Dim Count As Integer = 0
        With Com
            .Connection = App.Connection
            .CommandType = CommandType.StoredProcedure
            .Parameters.Add("@Id", SqlDbType.Int)
            For Each r As DataGridViewRow In DataGridView1.SelectedRows
                .Parameters(0).Value = r.Cells(0).Value
                count += .ExecuteNonQuery
            Next
            MsgBox(String.Format("{0} rows deleted", Count))
            LoadData()
        End With
    End Sub

    Private Sub LoadDataToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadDataToolStripMenuItem.Click
        LoadSales()
    End Sub
    Private Sub LoadSales()
        Dim T As New AdventureWorksDataSet.SalesReasonDataTable
        Dim TA As New AdventureWorksDataSetTableAdapters.SalesReasonTableAdapter
        TA.Fill(T)
        DataGridView1.DataSource = T
    End Sub

    Private Sub DeleteSelectedSPToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteSelectedSPToolStripMenuItem.Click
        Dim Com As New SqlClient.SqlCommand("Sales.SalesReason_DeleteChecked")
        Dim Count As Integer = 0
        With Com
            .Connection = App.Connection
            .CommandType = CommandType.StoredProcedure
            .Parameters.Add("@SalesReasonId", SqlDbType.Int)
            .Parameters.Add("@CheckStamp", SqlDbType.BigInt)
            With .Parameters.Add("@DeletedRecords", SqlDbType.Int)
                .Direction = ParameterDirection.Output
            End With
            For Each r As DataGridViewRow In DataGridView1.SelectedRows
                .Parameters(0).Value = r.Cells(0).Value
                .Parameters(1).Value = r.Cells("LastVersion").Value
                Try
                    .ExecuteNonQuery()
                    Count += CInt(.Parameters(2).Value)
                Catch ex As SqlClient.SqlException
                    Select Case ex.Number
                        Case 547 'Referential integrity
                            MsgBox("This information has other related pieces of information. You can't remove it", MsgBoxStyle.Exclamation)
                            'Continue adding your own control actions here
                        Case Else
                            MsgBox("Unspecified error. Can't delete", MsgBoxStyle.Critical)
                    End Select

                Catch ex As Exception
                    MsgBox(ex.Message, MsgBoxStyle.Critical)
                End Try
            Next
            MsgBox(String.Format("{0} rows deleted", Count))
            LoadSales()
        End With
    End Sub
End Class
