Public Class SubCategories

    Private Sub SubCategories_Load( _
        ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load
        SubCategories_GetAllTableAdapter1.Fill(AdvWorks1.SubCategories_GetAll)
        ProductCategoryTableAdapter1.Fill(AdvWorks1.ProductCategory)
    End Sub

    Private Sub DataGridView1_RowEnter( _
        ByVal sender As Object, _
        ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) _
    Handles DataGridView1.RowEnter
        With SubCategories_GetOneTableAdapter1
            .Fill( _
                AdvWorks1.SubCategories_GetOne, _
                AdvWorks1.SubCategories_GetAll.Rows(e.RowIndex).Item(0))
        End With
    End Sub

    Private Sub Button1_Click( _
        ByVal sender As System.Object, _
        ByVal e As System.EventArgs) _
    Handles Button1.Click
        Try
            AdvWorks1.SubCategories_GetOne.Rows(0).EndEdit()
            SubCategories_GetOneTableAdapter1.Update( _
                AdvWorks1.SubCategories_GetOne)
            SubCategories_GetAllTableAdapter1.Fill( _
                AdvWorks1.SubCategories_GetAll)
        Catch ex As SqlClient.SqlException
            Select Case ex.Number
                Case 547
                    MsgBox("Please, select one of the categories")
                    ComboBox1.Focus()
                Case Else
                    MsgBox(ex.Message)
            End Select
        Catch ex As Exception

        End Try
    End Sub

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
        With AdvWorks1.SubCategories_GetOne
            .Clear() 'remove any previous row 
            'Create a new row
            Dim r As AdvWorks.SubCategories_GetOneRow = _
                .NewSubCategories_GetOneRow
            'Assign default values to each column
            r.ProductCategoryID = 0
            r.Name = ""
            r.rowguid = Guid.NewGuid
            r.ModifiedDate = System.DateTime.Now
            'Add the row to the table
            .AddSubCategories_GetOneRow(r)
        End With
    End Sub

    Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton2.Click
        If MsgBox("Do you want to delete the selected sub category?", _
            MsgBoxStyle.Question Or MsgBoxStyle.YesNo) = MsgBoxResult.Yes Then
            Try
                'Get the row depending on the selected cell in the Gridview
                With SubCategories_GetOneTableAdapter1
                    .Fill( _
                        AdvWorks1.SubCategories_GetOne, _
                        AdvWorks1.SubCategories_GetAll.Rows( _
                        DataGridView1.SelectedCells(0).RowIndex).Item(0))
                    'Delete the row in the DataTable
                    AdvWorks1.SubCategories_GetOne.Rows(0).Delete()
                    'Update the changes to the database
                    .Update(AdvWorks1.SubCategories_GetOne)
                End With
                'reload the Datagrid rows
                SubCategories_GetAllTableAdapter1.Fill( _
                    AdvWorks1.SubCategories_GetAll)
            Catch ex As SqlClient.SqlException
                Select Case ex.Number
                    Case 547 'Referential error.
                        'In this case, the row has related rows in other tables
                        MsgBox("Cannot delete. The subcategory is in use in some Products")
                    Case Else
                        MsgBox(ex.Message)
                End Select

            Catch ex As Exception
                MsgBox(ex.Message)
            End Try
        End If
    End Sub
End Class
