CREATE PROCEDURE [Production].[SubcategoryUpdate]
   @SubcategoryID int,
   @Name nvarchar(50),
   @CategoryName nvarchar(50)=null
   
AS
BEGIN
   UPDATE [AdventureWorks].[Production].[ProductSubcategory]
      SET 
       [Name] = @Name
      ,[ModifiedDate] = GETDATE()
      WHERE ProductSubcategoryID=@SubcategoryID
   -- Check if we receive a Category Name
   IF NOT @CategoryName IS NULL
      -- Update the Category Name
      UPDATE [AdventureWorks].[Production].[ProductCategory]
         SET 
             [Name] = @CategoryName
            ,[rowguid] = NEWID()
            ,[ModifiedDate] = GETDATE()
         WHERE 
         ProductCategoryID=
          (
             SELECT ProductCategoryID
            FROM Production.ProductSubcategory
            WHERE (ProductSubcategoryID = @SubCategoryID)
          )
END
 