CREATE PROCEDURE [Person].[AddressTypeFullUpdate]
   @AddressTypeID int OUTPUT,
   @Name nvarchar(50) OUTPUT,
   @rowguid uniqueidentifier=null OUTPUT,
   @ModifiedDate datetime=null OUTPUT
AS
-- Check if a row exists with the same AddressTypeID
IF exists(
         SELECT AddressTypeID
         FROM Person.AddressType
         WHERE (AddressTypeID = @AddressTypeID)
      )
   BEGIN -- Update the existing row
      UPDATE [AdventureWorks].[Person].[AddressType]
         SET [Name] = @Name
           ,[rowguid] = NEWID()
           ,[ModifiedDate] = GETDATE()
       WHERE AddressTypeID = @AddressTypeID
   END
ELSE
   BEGIN -- Insert a new row
      INSERT INTO [AdventureWorks].[Person].[AddressType]
               ([Name]
               ,[rowguid]
               ,[ModifiedDate])
          VALUES
               (@Name
               ,NEWID(),
               ,@GETDATE())
   -- Retrieve the new AddressTypeID
   SET @AddressTypeID=IDENT_CURRENT('Person.AddressType')
   END
-- Assign the actual values from the row to the parameters
SELECT   @AddressTypeID=AddressTypeID,
      @Name=Name,
      @rowguid=rowguid,
      @ModifiedDate=ModifiedDate
FROM [AdventureWorks].[Person].[AddressType]
WHERE (AddressTypeID = @AddressTypeID)
 